LookupTable.Strategy (Media Authoring with Java API)
Date: 2016-02-05

tv.amwa.maj.util

## Enum LookupTable.Strategy

- java.lang.Object
- - java.lang.Enum<LookupTable.Strategy>
  - - tv.amwa.maj.util.LookupTable.Strategy

- All Implemented Interfaces:
    Serializable, Comparable<LookupTable.Strategy>
  Enclosing class:
    LookupTable

      public static enum LookupTable.Strategy
      extends Enum<LookupTable.Strategy>

  Defines the kind of strategy used to represent a particular AAF data type in the MAJ API.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `AbstractUnion` The representation of a data type in the C-based AAF SDK defined as a `union`.
    `Annotation` The representation of an AAF data type using a Java class or primitive type that should also be labelled with an annotation taken from the integer or miscellaneous type packages.
    `Class` The representation of an AAF data type using a Java interface and implementing class.
    `Enumeration` The representation of the AAF data type uses a Java enumeration.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static LookupTable.Strategy` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static LookupTable.Strategy[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `compareTo, equals, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### Enumeration

          public static final LookupTable.Strategy Enumeration

      The representation of the AAF data type uses a Java enumeration. For example, the AAF enumeration `EditHintType` defined in the AAF object specification is represented by the Java enumeration `EditHintType`. All such enumerations are defined in the enumeration package.

    - #### Class

          public static final LookupTable.Strategy Class

      The representation of an AAF data type using a Java interface and implementing class. For example, the AAF data type `Timestamp` is represented in Java by the interface `TimeStamp`. The fields of the AAF data type as defined as a C structure in the AAF SDK have been translated to get and set methods of the interface.

    - #### Annotation

          public static final LookupTable.Strategy Annotation

      The representation of an AAF data type using a Java class or primitive type that should also be labelled with an annotation taken from the integer or miscellaneous type packages. For example, the `FrameOffset` AAF type is represented in Java by the primitive type `long` and values should be labelled with the Java annotation `FrameOffset`.

    - #### AbstractUnion

          public static final LookupTable.Strategy AbstractUnion

      The representation of a data type in the C-based AAF SDK defined as a `union`. This is represented in Java as an abstract interface that is inherited by sub-interfaces representing the alternative values of the C union. Examples of interfaces for abstract union classes can be found in the union package, with implementations in the argument package.

  - ### Method Detail

    - #### values

          public static LookupTable.Strategy[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (LookupTable.Strategy c : LookupTable.Strategy.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static LookupTable.Strategy valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

(c)2007-2016 Richard Cartwright, all rights reserved. Licensed under Apache 2 license and subject to the AMWA IPR policy.